diff -uNr -x CVS u-boot-cvs/CREDITS u-boot/CREDITS
--- u-boot-cvs/CREDITS	2004-06-26 22:08:56.000000000 +0900
+++ u-boot/CREDITS	2004-06-26 23:21:02.000000000 +0900
@@ -328,6 +328,10 @@
 E: r.schwebel@pengutronix.de
 D: Support for csb226, logodl and innokom boards (PXA2xx)
 
+N: Yasushi Shoji
+E: yashi@atmark-techno.com
+D: Support for MicroBlaze CPU, for SUZAKU FPGA board
+
 N: Kurt Stremerch
 E: kurt@exys.be
 D: Support for Exys XSEngine board
diff -uNr -x CVS u-boot-cvs/MAINTAINERS u-boot/MAINTAINERS
--- u-boot-cvs/MAINTAINERS	2004-06-26 22:08:56.000000000 +0900
+++ u-boot/MAINTAINERS	2004-06-26 23:22:54.000000000 +0900
@@ -421,5 +421,16 @@
 	DK1C20			Nios-32
 
 #########################################################################
+# MicroBlaze Systems:							#
+#									#
+# Maintainer Name, Email Address					#
+#	Board			CPU					#
+#########################################################################
+
+Yasushi Shoji <yashi@atmark-techno.com>
+
+	SUZAKU			MicroBlaze
+
+#########################################################################
 # End of MAINTAINERS list						#
 #########################################################################
diff -uNr -x CVS u-boot-cvs/MAKEALL u-boot/MAKEALL
--- u-boot-cvs/MAKEALL	2004-06-26 22:08:56.000000000 +0900
+++ u-boot/MAKEALL	2004-06-26 22:59:30.000000000 +0900
@@ -187,6 +187,12 @@
 	DK1S10 DK1S10_standard_32 DK1S10_mtx_ldk_20			\
 "
 
+#########################################################################
+## MicroBlaze Systems
+#########################################################################
+
+LIST_microblaze="suzaku"
+
 #-----------------------------------------------------------------------
 
 #----- for now, just run PPC by default -----
diff -uNr -x CVS u-boot-cvs/README u-boot/README
--- u-boot-cvs/README	2004-06-26 22:08:56.000000000 +0900
+++ u-boot/README	2004-06-26 23:14:17.000000000 +0900
@@ -119,47 +119,49 @@
 Directory Hierarchy:
 ====================
 
-- board		Board dependent files
-- common	Misc architecture independent functions
-- cpu		CPU specific files
-  - 74xx_7xx	Files specific to Motorola MPC74xx and 7xx CPUs
-  - arm720t	Files specific to ARM 720 CPUs
-  - arm920t	Files specific to ARM 920 CPUs
-  - arm925t	Files specific to ARM 925 CPUs
-  - arm926ejs	Files specific to ARM 926 CPUs
-  - at91rm9200	Files specific to Atmel AT91RM9200 CPUs
-  - i386	Files specific to i386 CPUs
-  - ixp		Files specific to Intel XScale IXP CPUs
-  - mcf52x2	Files specific to Motorola ColdFire MCF52x2 CPUs
-  - mips	Files specific to MIPS CPUs
-  - mpc5xx	Files specific to Motorola MPC5xx  CPUs
-  - mpc5xxx	Files specific to Motorola MPC5xxx CPUs
-  - mpc8xx	Files specific to Motorola MPC8xx  CPUs
-  - mpc824x	Files specific to Motorola MPC824x CPUs
-  - mpc8260	Files specific to Motorola MPC8260 CPUs
-  - mpc85xx	Files specific to Motorola MPC85xx CPUs
-  - nios	Files specific to Altera NIOS CPUs
-  - ppc4xx	Files specific to IBM PowerPC 4xx CPUs
-  - pxa		Files specific to Intel XScale PXA CPUs
-  - s3c44b0	Files specific to Samsung S3C44B0 CPUs
-  - sa1100	Files specific to Intel StrongARM SA1100 CPUs
-- disk		Code for disk drive partition handling
-- doc		Documentation (don't expect too much)
-- drivers	Commonly used device drivers
-- dtt		Digital Thermometer and Thermostat drivers
-- examples	Example code for standalone applications, etc.
-- include	Header Files
-- lib_arm	Files generic to ARM	 architecture
-- lib_generic	Files generic to all	 architectures
-- lib_i386	Files generic to i386	 architecture
-- lib_m68k	Files generic to m68k	 architecture
-- lib_mips	Files generic to MIPS	 architecture
-- lib_nios	Files generic to NIOS	 architecture
-- lib_ppc	Files generic to PowerPC architecture
-- net		Networking code
-- post		Power On Self Test
-- rtc		Real Time Clock drivers
-- tools		Tools to build S-Record or U-Boot images, etc.
+- board			Board dependent files
+- common		Misc architecture independent functions
+- cpu			CPU specific files
+  - 74xx_7xx		Files specific to Motorola MPC74xx and 7xx CPUs
+  - arm720t		Files specific to ARM 720 CPUs
+  - arm920t		Files specific to ARM 920 CPUs
+  - arm925t		Files specific to ARM 925 CPUs
+  - arm926ejs		Files specific to ARM 926 CPUs
+  - at91rm9200		Files specific to Atmel AT91RM9200 CPUs
+  - i386		Files specific to i386 CPUs
+  - ixp			Files specific to Intel XScale IXP CPUs
+  - mcf52x2		Files specific to Motorola ColdFire MCF52x2 CPUs
+  - microblaze		Files specific to Xilinx MicroBlaze
+  - mips		Files specific to MIPS CPUs
+  - mpc5xx		Files specific to Motorola MPC5xx  CPUs
+  - mpc5xxx		Files specific to Motorola MPC5xxx CPUs
+  - mpc8xx		Files specific to Motorola MPC8xx  CPUs
+  - mpc824x		Files specific to Motorola MPC824x CPUs
+  - mpc8260		Files specific to Motorola MPC8260 CPUs
+  - mpc85xx		Files specific to Motorola MPC85xx CPUs
+  - nios		Files specific to Altera NIOS CPUs
+  - ppc4xx		Files specific to IBM PowerPC 4xx CPUs
+  - pxa			Files specific to Intel XScale PXA CPUs
+  - s3c44b0		Files specific to Samsung S3C44B0 CPUs
+  - sa1100		Files specific to Intel StrongARM SA1100 CPUs
+- disk			Code for disk drive partition handling
+- doc			Documentation (don't expect too much)
+- drivers		Commonly used device drivers
+- dtt			Digital Thermometer and Thermostat drivers
+- examples		Example code for standalone applications, etc.
+- include		Header Files
+- lib_arm		Files generic to ARM		architecture
+- lib_generic		Files generic to all		architectures
+- lib_i386		Files generic to i386		architecture
+- lib_m68k		Files generic to m68k		architecture
+- lib_microblaze	Files generic to MicroBlaze	architecture
+- lib_mips		Files generic to MIPS		architecture
+- lib_nios		Files generic to NIOS		architecture
+- lib_ppc		Files generic to PowerPC	architecture
+- net			Networking code
+- post			Power On Self Test
+- rtc			Real Time Clock drivers
+- tools			Tools to build S-Record or U-Boot images, etc.
 
 Software Configuration:
 =======================
diff -uNr -x CVS u-boot-cvs/include/asm-microblaze/processor.h u-boot/include/asm-microblaze/processor.h
--- u-boot-cvs/include/asm-microblaze/processor.h	1970-01-01 09:00:00.000000000 +0900
+++ u-boot/include/asm-microblaze/processor.h	2004-06-26 23:01:31.000000000 +0900
@@ -0,0 +1 @@
+/* FIXME: Implement this! */